#!/usr/bin/python3

from skimage.restoration import denoise_tv_chambolle
from skimage import img_as_float
import numpy as np
from PIL import Image
import os
from tqdm import tqdm

imagesFolderPath = 'flat-field'
npArrayFilePath = 'mean.npy'

mean = None
numberOfImagesInMean = 0

imagesFileNames = os.listdir(imagesFolderPath)

def treatImage(imageFileName):
    global mean, numberOfImagesInMean
    imageFilePath = f'{imagesFolderPath}/{imageFileName}'
    imagePil = Image.open(imageFilePath)
    imageNpArray = img_as_float(np.array(imagePil))
    imageDenoisedNpArray = denoise_tv_chambolle(imageNpArray, weight=0.2, channel_axis=-1)
    imageNoiseNpArray = imageNpArray - imageDenoisedNpArray
    if mean is None:
        mean = imageNoiseNpArray
    else:
        mean = ((mean * numberOfImagesInMean) + imageNoiseNpArray) / (numberOfImagesInMean + 1)
    numberOfImagesInMean += 1

for imageFileName in tqdm(imagesFileNames):
    treatImage(imageFileName)

with open(npArrayFilePath, 'wb') as f:
    np.save(f, mean)
